﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=6.3
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	Public client As MqttClient
	Public connected As Boolean
	Public kvs As KeyValueStore
	Public rp As RuntimePermissions
	'Private astream As AsyncStreams
	Public const rdcLink As String = "http://partestelco.semi.es:8090/rdc"
	'Public const rdcLink As String = "http://192.168.1.129:8090/rdc"
End Sub

Sub Service_Create
	DateTime.DateFormat = DateTime.DeviceDefaultDateFormat
	'kvs.Initialize(rp.GetSafeDirDefaultExternal(""), "kvs")
	CallSubDelayed(FirebaseMessaging, "SubscribeToTopics")
	connected = False
	'client.Initialize("client", "tcp://192.168.1.254:1883", "android")
	'ConectarMQTT
	
End Sub

Sub ConnectMQTT
	client.Initialize("client", "tcp://your_ip:port_here", "android")
	Dim options As MqttConnectOptions
	options.Initialize("user", "password")
	client.Connect2(options)
	
End Sub

Sub client_Connected (Success As Boolean)
	connected = Success
	If Success Then
		'ToastMessageShow("Conectado!", False)
		CallSubDelayed(Main, "Active_Buttons")
	Else
		ToastMessageShow("Error connecting, ¿are you connected to internet?: " & LastException, True)
	End If
	
End Sub

Public Sub OpenDoor(Door As String)
	Log("OpenDoor: " & Door)
	If Not (connected) Then
		ConnectMQTT
		Log("Waiting connection")
		Wait For client_Connected (Success As Boolean)
		If Success Then
			Log("Mqtt connected")
			client.Publish("esp", Door.GetBytes("UTF8"))
			ToastMessageShow("Opening door " & Door, True)
		Else
			ToastMessageShow("There was an error connecting to mqtt: " & LastException, True)
		End If
	Else
		client.Publish("esp", Door.GetBytes("UTF8"))
		ToastMessageShow("Opening Door " & Door, True)
	End If
End Sub

Sub client_Disconnected
	connected = False
	Log("Disconnected mqtt")
	'CallSub(Main, "SetState")
End Sub

Sub client_MessageArrived (Topic As String, Payload() As Byte)
	
End Sub

Sub Service_Start (StartingIntent As Intent)
	
End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub


